TagLib::MPEG::File Class Reference

An MPEG file class with some useful methods specific to MPEG. More...

`#include <mpegfile.h>`

Inheritance diagram for TagLib::MPEG::File:
[legend]
Collaboration diagram for TagLib::MPEG::File:
[legend]

## Public Types

enum | TagTypes { NoTags = 0x0000 , ID3v1 = 0x0001 , ID3v2 = 0x0002 , APE = 0x0004 , AllTags = 0xffff }
Public Types inherited from TagLib::File
enum | Position { Beginning , Current , End }
enum | StripTags { StripNone , StripOthers }
enum | DuplicateTags { Duplicate , DoNotDuplicate }

## Public Member Functions

| File (FileName file, bool readProperties=true, Properties::ReadStyle readStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
TAGLIB_DEPRECATED | File (FileName file, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle readStyle=Properties::Average)
| File (IOStream *stream, bool readProperties=true, Properties::ReadStyle readStyle=Properties::Average, ID3v2::FrameFactory *frameFactory=nullptr)
TAGLIB_DEPRECATED | File (IOStream *stream, ID3v2::FrameFactory *frameFactory, bool readProperties=true, Properties::ReadStyle readStyle=Properties::Average)
| ~File () override
| File (const File &)=delete
File & | operator= (const File &)=delete
Tag * | tag () const override
PropertyMap | properties () const override
void | removeUnsupportedProperties (const StringList &properties) override
PropertyMap | setProperties (const PropertyMap &) override
Properties * | audioProperties () const override
bool | save () override
bool | save (int tags, StripTags strip=StripOthers, ID3v2::Version version=ID3v2::v4, DuplicateTags duplicate=Duplicate)
ID3v2::Tag * | ID3v2Tag (bool create=false)
ID3v1::Tag * | ID3v1Tag (bool create=false)
APE::Tag * | APETag (bool create=false)
bool | strip (int tags=AllTags, bool freeMemory=true)
offset_t | firstFrameOffset ()
offset_t | nextFrameOffset (offset_t position)
offset_t | previousFrameOffset (offset_t position)
offset_t | lastFrameOffset ()
bool | hasID3v1Tag () const
bool | hasID3v2Tag () const
bool | hasAPETag () const
Public Member Functions inherited from TagLib::File
| File (const File &)=delete
File & | operator= (const File &)=delete
FileName | name () const
virtual StringList | complexPropertyKeys () const
virtual List< VariantMap > | complexProperties (const String &key) const
virtual bool | setComplexProperties (const String &key, const List< VariantMap > &value)
ByteVector | readBlock (size_t length)
void | writeBlock (const ByteVector &data)
offset_t | find (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
offset_t | rfind (const ByteVector &pattern, offset_t fromOffset=0, const ByteVector &before=ByteVector())
void | insert (const ByteVector &data, offset_t start=0, size_t replace=0)
void | removeBlock (offset_t start=0, size_t length=0)
bool | readOnly () const
bool | isOpen () const
bool | isValid () const
void | seek (offset_t offset, Position p=Beginning)
void | clear ()
offset_t | tell () const
offset_t | length ()

## Static Public Member Functions

static bool | isSupported (IOStream *stream)

## Additional Inherited Members

Protected Member Functions inherited from TagLib::File
| File (FileName fileName)
| File (IOStream *stream)
void | setValid (bool valid)
void | truncate (offset_t length)
Static Protected Member Functions inherited from TagLib::File
static unsigned int | bufferSize ()

## Detailed Description

An MPEG file class with some useful methods specific to MPEG.

This implements the generic TagLib::File API and additionally provides access to properties that are distinct to MPEG files, notably access to the different ID3 tags.

## Member Enumeration Documentation

## TagTypes

enum TagLib::MPEG::File::TagTypes

This set of flags is used for various operations and is suitable for being OR-ed together.

Enumerator
NoTags | Empty set. Matches no tag types.
ID3v1 | Matches ID3v1 tags.
ID3v2 | Matches ID3v2 tags.
APE | Matches APE tags.
AllTags | Matches all tag types.

## Constructor & Destructor Documentation

## File() [1/5]

TagLib::MPEG::File::File | ( | FileName | file,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | readStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs an MPEG file from file. If readProperties is `true` the file's audio properties will also be read.

If readStyle is not Fast, the file will be scanned completely if no ID3v2 tag or MPEG sync code is found at the start.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average, and TAGLIB_DEPRECATED.

Referenced by File(), and operator=().

## File() [2/5]

TAGLIB_DEPRECATED TagLib::MPEG::File::File | ( | FileName | file,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | readStyle = Properties::Average )

Constructs an MPEG file from file. If readProperties is `true` the file's audio properties will also be read.

If this file contains an ID3v2 tag, the frames will be created using frameFactory.

If readStyle is not Fast, the file will be scanned completely if no ID3v2 tag or MPEG sync code is found at the start.

Deprecated
  Use the constructor above.

References TagLib::AudioProperties::Average.

## File() [3/5]

TagLib::MPEG::File::File | ( | IOStream * | stream,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | readStyle = Properties::Average,
|  | ID3v2::FrameFactory * | frameFactory = nullptr )

Constructs an MPEG file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

If this file contains an ID3v2 tag, the frames will be created using frameFactory.

If readStyle is not Fast, the file will be scanned completely if no ID3v2 tag or MPEG sync code is found at the start.

If this file contains an ID3v2 tag, the frames will be created using frameFactory (default if null).

References TagLib::AudioProperties::Average, and TAGLIB_DEPRECATED.

## File() [4/5]

TAGLIB_DEPRECATED TagLib::MPEG::File::File | ( | IOStream * | stream,
|  | ID3v2::FrameFactory * | frameFactory,
|  | bool | readProperties = true,
|  | Properties::ReadStyle | readStyle = Properties::Average )

Constructs an MPEG file from stream. If readProperties is `true` the file's audio properties will also be read.

Note
  TagLib will not take ownership of the stream, the caller is responsible for deleting it after the File object.

If this file contains an ID3v2 tag, the frames will be created using frameFactory.

If readStyle is not Fast, the file will be scanned completely if no ID3v2 tag or MPEG sync code is found at the start.

Deprecated
  Use the constructor above.

References TagLib::AudioProperties::Average.

## ~File()

TagLib::MPEG::File::~File | ( |  | ) |

override virtual

Destroys this instance of the File.

Reimplemented from TagLib::File.

## File() [5/5]

TagLib::MPEG::File::File | ( | const File & |  | ) |

delete

References File().

## Member Function Documentation

## APETag()

APE::Tag * TagLib::MPEG::File::APETag | ( | bool | create = false | ) |

Returns a pointer to the APE tag of the file.

If create is `false` (the default) this may return a null pointer if there is no valid APE tag. If create is `true` it will create an APE tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an APE tag. Use hasAPETag() to check if the file on disk actually has an APE tag.
  The Tag is still owned by the MPEG::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasAPETag()

## audioProperties()

Properties * TagLib::MPEG::File::audioProperties | ( |  | ) | const

override virtual

Returns the MPEG::Properties for this file. If no audio properties were read then this will return a null pointer.

Implements TagLib::File.

## firstFrameOffset()

offset_t TagLib::MPEG::File::firstFrameOffset | ( |  | ) |

Returns the position in the file of the first MPEG frame.

## hasAPETag()

bool TagLib::MPEG::File::hasAPETag | ( |  | ) | const

Returns whether or not the file on disk actually has an APE tag.

See also
  APETag()

## hasID3v1Tag()

bool TagLib::MPEG::File::hasID3v1Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v1 tag.

See also
  ID3v1Tag()

## hasID3v2Tag()

bool TagLib::MPEG::File::hasID3v2Tag | ( |  | ) | const

Returns whether or not the file on disk actually has an ID3v2 tag.

See also
  ID3v2Tag()

## ID3v1Tag()

ID3v1::Tag * TagLib::MPEG::File::ID3v1Tag | ( | bool | create = false | ) |

Returns a pointer to the ID3v1 tag of the file.

If create is `false` (the default) this may return a null pointer if there is no valid ID3v1 tag. If create is `true` it will create an ID3v1 tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v1 tag. Use hasID3v1Tag() to check if the file on disk actually has an ID3v1 tag.
  The Tag is still owned by the MPEG::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v1Tag()

## ID3v2Tag()

ID3v2::Tag * TagLib::MPEG::File::ID3v2Tag | ( | bool | create = false | ) |

Returns a pointer to the ID3v2 tag of the file.

If create is `false` (the default) this may return a null pointer if there is no valid ID3v2 tag. If create is `true` it will create an ID3v2 tag if one does not exist and returns a valid pointer.

Note
  This may return a valid pointer regardless of whether or not the file on disk has an ID3v2 tag. Use hasID3v2Tag() to check if the file on disk actually has an ID3v2 tag.
  The Tag is still owned by the MPEG::File and should not be deleted by the user. It will be deleted when the file (object) is destroyed.

See also
  hasID3v2Tag()

## isSupported()

bool TagLib::MPEG::File::isSupported | ( | IOStream * | stream | ) |

static

Returns whether or not the given stream can be opened as an MPEG file.

Note
  This method is designed to do a quick check. The result may not necessarily be correct.

References TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## lastFrameOffset()

offset_t TagLib::MPEG::File::lastFrameOffset | ( |  | ) |

Returns the position in the file of the last MPEG frame.

## nextFrameOffset()

offset_t TagLib::MPEG::File::nextFrameOffset | ( | offset_t | position | ) |

Returns the position in the file of the next MPEG frame, using the current position as start.

## operator=()

File & TagLib::MPEG::File::operator= | ( | const File & |  | ) |

delete

References File().

## previousFrameOffset()

offset_t TagLib::MPEG::File::previousFrameOffset | ( | offset_t | position | ) |

Returns the position in the file of the previous MPEG frame, using the current position as start.

## properties()

PropertyMap TagLib::MPEG::File::properties | ( |  | ) | const

override virtual

Implements the reading part of the unified property interface. If the file contains more than one tag, only the first one (in the order ID3v2, APE, ID3v1) will be converted to the PropertyMap.

Reimplemented from TagLib::File.

Referenced by removeUnsupportedProperties().

## removeUnsupportedProperties()

void TagLib::MPEG::File::removeUnsupportedProperties | ( | const StringList & | properties | ) |

override virtual

Removes unsupported properties, or a subset of them, from the file's metadata. The parameter properties must contain only entries from properties().unsupportedData().

Reimplemented from TagLib::File.

References properties().

## save() [1/2]

bool TagLib::MPEG::File::save | ( |  | ) |

override virtual

Save the file. If at least one tag – ID3v1 or ID3v2 – exists this will duplicate its content into the other tag. This returns `true` if saving was successful.

If neither exists or if both tags are empty, this will strip the tags from the file.

This is the same as calling save(AllTags);

If you would like more granular control over the content of the tags, with the concession of generality, use parameterized save call below.

See also
  save(int tags)

Implements TagLib::File.

## save() [2/2]

bool TagLib::MPEG::File::save | ( | int | tags,
|  | StripTags | strip = StripOthers,
|  | ID3v2::Version | version = ID3v2::v4,
|  | DuplicateTags | duplicate = Duplicate )

Save the file. This will attempt to save all of the tag types that are specified by OR-ing together TagTypes values.

strip can be set to strip all tags except those in tags. Those tags will not be modified in memory, and thus remain valid.

version specifies the ID3v2 version to be used for writing tags. By default, the latest standard, ID3v2.4 is used.

If duplicate is set to Duplicate and at least one tag – ID3v1 or ID3v2 – exists this will duplicate its content into the other tag.

References TagLib::File::Duplicate, strip(), TagLib::File::StripOthers, and TagLib::ID3v2::v4.

## setProperties()

PropertyMap TagLib::MPEG::File::setProperties | ( | const PropertyMap & |  | ) |

override virtual

Implements the writing part of the unified tag dictionary interface. In order to avoid problems with deprecated tag formats, this method always creates an ID3v2 tag if necessary. If an ID3v1 tag exists, it will be updated as well, within the limitations of that format. The returned PropertyMap refers to the ID3v2 tag only.

Reimplemented from TagLib::File.

## strip()

bool TagLib::MPEG::File::strip | ( | int | tags = AllTags,
|  | bool | freeMemory = true )

This will strip the tags that match the OR-ed together TagTypes from the file. By default it strips all tags. It returns `true` if the tags are successfully stripped.

If freeMemory is `true` the ID3 and APE tags will be deleted and pointers to them will be invalidated.

Note
  This will update the file immediately.

References AllTags.

Referenced by save().

## tag()

Tag * TagLib::MPEG::File::tag | ( |  | ) | const

override virtual

Returns a pointer to a tag that is the union of the ID3v2 and ID3v1 tags. The ID3v2 tag is given priority in reading the information – if requested information exists in both the ID3v2 tag and the ID3v1 tag, the information from the ID3v2 tag will be returned.

If you would like more granular control over the content of the tags, with the concession of generality, use the tag-type specific calls.

Note
  As this tag is not implemented as an ID3v2 tag or an ID3v1 tag, but a union of the two this pointer may not be cast to the specific tag types.

See also
  ID3v1Tag()
  ID3v2Tag()
  APETag()

Implements TagLib::File.

The documentation for this class was generated from the following file:

- mpegfile.h